Unit AV02C_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

function AV02C(var A :Array of Complex; N :Integer): Real;

implementation

function AV02C(var A :Array of Complex; N :Integer): Real;
var
I :Integer;
G,Z1,E,F,D :Real;
S :Complex;
const
SYS056 :Real = 1.175495E-38;
label
_1,_2,_3,_4;
begin
{ Result -    AV02C  FORTRANe }
{      SYS056 = SYS055 }
Z1 := 0.0;
for I:=1 to N do
 begin
  G := Cabs(A[I-1]);
  if ( Z1 >= G ) 
   then goto _1;
  Z1 := G;
_1:
 end;
if ( Z1 >= SYS056 ) 
 then goto _2;
Result := 0.0;
goto _4;
_2:
D := 0.0;
G := 1.0/Z1;
for I:=1 to N do
 begin
  S := A[I-1];
  E := Aimag(S)*G;
  F := Creal(S)*G;
_3:
  D := D+F*F+E*E;
 end;
Result := Sqrt(D)*Z1;
_4:
exit;
end;

end.
